diff --git a/linux-2.6.37.6-antonio/arch/microblaze/boot/dts/system.dts b/linux-2.6.37.6-antonio/arch/microblaze/boot/dts/system.dts
new file mode 120000
index 0000000..7cb6578
--- /dev/null
+++ b/linux-2.6.37.6-antonio/arch/microblaze/boot/dts/system.dts
@@ -0,0 +1 @@
+../../platform/generic/system.dts
\ No newline at end of file
diff --git a/linux-2.6.37.6-antonio/arch/x86/Kconfig b/linux-2.6.37.6-antonio/arch/x86/Kconfig
index 57e823a..1cb5d8e 100644
--- a/linux-2.6.37.6-antonio/arch/x86/Kconfig
+++ b/linux-2.6.37.6-antonio/arch/x86/Kconfig
@@ -2101,7 +2101,6 @@ config SYSVIPC_COMPAT
 
 endmenu
 
-
 config HAVE_ATOMIC_IOMAP
 	def_bool y
 	depends on X86_32
@@ -2109,6 +2108,81 @@ config HAVE_ATOMIC_IOMAP
 config HAVE_TEXT_POKE_SMP
 	bool
 	select STOP_MACHINE if SMP
+	
+menu "Software Transactional Memory"
+
+config STM_ENABLE
+	bool "Enable Software Transactional Memory support"
+	---help---
+	  In kernel Software Transactional Memory
+	 
+choice
+	prompt "Enable debugging"
+	default STM_NODEBUG
+	depends on STM_ENABLE
+	---help---
+	  disable deugging for preformance measurement
+	  
+	config STM_NODEBUG
+		bool "no debugging support for STM"
+	config STM_DEBUG
+		bool "basic debug support"
+	config STM_DEBUG2
+		bool "a bit more debug support"
+	config STM_DEBUG3
+		bool "debugging support enabled in every submodules"
+endchoice
+
+choice
+	prompt "Contention Manager"
+	default STM_CM_DELAY
+	depends on STM_ENABLE
+	---help---
+	  Suicide is the default contention manager, different options
+	  require the Delay contention manager
+	  
+	config STM_CM_SUICIDE
+		bool "Suicide Contention Manager"
+	config STM_CM_DELAY
+		bool "Delay Contention Manager"
+endchoice
+
+choice
+	prompt "Contention Manager waiting strategy"
+	default STM_WAIT_SPIN
+	depends on STM_ENABLE && STM_CM_DELAY
+	---help---
+	  When a transaction is aborted and is delayed it must wait on 
+	  the winning transaction to commit
+	  
+	config STM_WAIT_SPIN
+		bool "default spinwait for the winning transaction to commit"
+	config STM_WAIT_YIELD
+		bool "Yield instead of spinwaiting delayed aborted transactions"
+	config STM_WAIT_COND
+		bool "Conditional waiting delayed aborted transactions"
+endchoice
+
+config STM_PREEMPT_AVOIDANCE
+	bool "STM Preempt Avoidance"
+	depends on STM_ENABLE
+	---help---
+	  stm preemption avoidance
+
+config STM_PREEMPT_BONUS
+	bool "STM Preempt Bonus"
+	depends on STM_PREEMPT_AVOIDANCE
+	---help---
+	  When a transactional thread avoid to be preempted at least once
+	  on commit it call yield after the commit is done. This happens also on abort. 
+
+config STM_MIGRATION_AVOIDANCE
+	bool "STM Migration Avoidance"
+	depends on STM_ENABLE
+	---help---
+	  stm migration avoidance
+
+endmenu	
 
 source "net/Kconfig"
 
diff --git a/linux-2.6.37.6-antonio/arch/x86/ia32/ia32entry.S b/linux-2.6.37.6-antonio/arch/x86/ia32/ia32entry.S
index 518bb99..030ea90 100644
--- a/linux-2.6.37.6-antonio/arch/x86/ia32/ia32entry.S
+++ b/linux-2.6.37.6-antonio/arch/x86/ia32/ia32entry.S
@@ -851,4 +851,5 @@ ia32_sys_call_table:
 	.quad sys_fanotify_init
 	.quad sys32_fanotify_mark
 	.quad sys_prlimit64		/* 340 */
+	.quad sys_checkpoint
 ia32_syscall_end:
diff --git a/linux-2.6.37.6-antonio/arch/x86/include/asm/unistd_32.h b/linux-2.6.37.6-antonio/arch/x86/include/asm/unistd_32.h
index b766a5e..f1fdb2d 100644
--- a/linux-2.6.37.6-antonio/arch/x86/include/asm/unistd_32.h
+++ b/linux-2.6.37.6-antonio/arch/x86/include/asm/unistd_32.h
@@ -346,10 +346,17 @@
 #define __NR_fanotify_init	338
 #define __NR_fanotify_mark	339
 #define __NR_prlimit64		340
+// checkpoint/rollback antonio old interface
+#define __NR_checkpoint		341
+#define __NR_rollback		342
+// checkpoint/rollback antonio current interface (refactored)
+#define __NR_snapshot		343
+// stm interface
+#define __NR_stm_ctrl		344
 
 #ifdef __KERNEL__
 
-#define NR_syscalls 341
+#define NR_syscalls 345
 
 #define __ARCH_WANT_IPC_PARSE_VERSION
 #define __ARCH_WANT_OLD_READDIR
diff --git a/linux-2.6.37.6-antonio/arch/x86/include/asm/unistd_64.h b/linux-2.6.37.6-antonio/arch/x86/include/asm/unistd_64.h
index 363e9b8..d3a72c1 100644
--- a/linux-2.6.37.6-antonio/arch/x86/include/asm/unistd_64.h
+++ b/linux-2.6.37.6-antonio/arch/x86/include/asm/unistd_64.h
@@ -670,6 +670,18 @@ __SYSCALL(__NR_fanotify_mark, sys_fanotify_mark)
 #define __NR_prlimit64				302
 __SYSCALL(__NR_prlimit64, sys_prlimit64)
 
+// checkpoint/rollback old interface (to be removed)
+#define __NR_checkpoint				303
+__SYSCALL(__NR_checkpoint, sys_checkpoint)
+#define __NR_rollback				304
+__SYSCALL(__NR_rollback, stub_rollback)
+// checkpoint/rollback current interface (refactored)
+#define __NR_snapshot				305
+__SYSCALL(__NR_snapshot, stub_snapshot)
+// stm control interface current
+#define __NR_stm_ctrl				306
+__SYSCALL(__NR_stm_ctrl, stub_stm_ctrl)
+
 #ifndef __NO_STUBS
 #define __ARCH_WANT_OLD_READDIR
 #define __ARCH_WANT_OLD_STAT
diff --git a/linux-2.6.37.6-antonio/arch/x86/kernel/entry_32.S b/linux-2.6.37.6-antonio/arch/x86/kernel/entry_32.S
index 591e601..02bccd1 100644
--- a/linux-2.6.37.6-antonio/arch/x86/kernel/entry_32.S
+++ b/linux-2.6.37.6-antonio/arch/x86/kernel/entry_32.S
@@ -732,6 +732,9 @@ PTREGSCALL0(sigreturn)
 PTREGSCALL0(rt_sigreturn)
 PTREGSCALL2(vm86)
 PTREGSCALL1(vm86old)
+PTREGSCALL1(rollback)
+PTREGSCALL3(snapshot)
+PTREGSCALL3(stm_ctrl)
 
 /* Clone is an oddball.  The 4th arg is in %edi */
 	ALIGN;
diff --git a/linux-2.6.37.6-antonio/arch/x86/kernel/entry_64.S b/linux-2.6.37.6-antonio/arch/x86/kernel/entry_64.S
index b235db9..573255e 100644
--- a/linux-2.6.37.6-antonio/arch/x86/kernel/entry_64.S
+++ b/linux-2.6.37.6-antonio/arch/x86/kernel/entry_64.S
@@ -686,6 +686,7 @@ END(\label)
 	PTREGSCALL stub_vfork, sys_vfork, %rdi
 	PTREGSCALL stub_sigaltstack, sys_sigaltstack, %rdx
 	PTREGSCALL stub_iopl, sys_iopl, %rsi
+	PTREGSCALL stub_rollback, sys_rollback, %rsi
 
 ENTRY(ptregscall_common)
 	DEFAULT_FRAME 1 8	/* offset 8: return address */
@@ -715,6 +716,36 @@ ENTRY(stub_execve)
 	CFI_ENDPROC
 END(stub_execve)
 
+ENTRY(stub_snapshot)
+	CFI_STARTPROC
+	addq $8, %rsp
+	PARTIAL_FRAME 0
+	SAVE_REST
+	FIXUP_TOP_OF_STACK %r11
+	movq %rsp, %rcx
+	call sys_snapshot
+	RESTORE_TOP_OF_STACK %r11
+	movq %rax,RAX(%rsp)
+	RESTORE_REST
+	jmp int_ret_from_sys_call
+	CFI_ENDPROC
+END(stub_snapshot)
+
+ENTRY(stub_stm_ctrl)
+	CFI_STARTPROC
+	addq $8, %rsp
+	PARTIAL_FRAME 0
+	SAVE_REST
+	FIXUP_TOP_OF_STACK %r11
+	movq %rsp, %rcx
+	call sys_stm_ctrl
+	RESTORE_TOP_OF_STACK %r11
+	movq %rax,RAX(%rsp)
+	RESTORE_REST
+	jmp int_ret_from_sys_call
+	CFI_ENDPROC
+END(stub_stm_ctrl)
+
 /*
  * sigreturn is special because it needs to restore all registers on return.
  * This cannot be done with SYSRET, so use the IRET return path instead.
diff --git a/linux-2.6.37.6-antonio/arch/x86/kernel/process_32.c b/linux-2.6.37.6-antonio/arch/x86/kernel/process_32.c
index 96586c3..95ab5ef 100644
--- a/linux-2.6.37.6-antonio/arch/x86/kernel/process_32.c
+++ b/linux-2.6.37.6-antonio/arch/x86/kernel/process_32.c
@@ -136,7 +136,7 @@ void __show_regs(struct pt_regs *regs, int all)
 		gs = get_user_gs(regs);
 	} else {
 		sp = kernel_stack_pointer(regs);
-		savesegment(ss, ss);
+		savesegment(ss, ss); // salva il contenuto del registro ss nella variabile ss
 		savesegment(gs, gs);
 	}
 
diff --git a/linux-2.6.37.6-antonio/arch/x86/kernel/syscall_table_32.S b/linux-2.6.37.6-antonio/arch/x86/kernel/syscall_table_32.S
index b35786d..675f309 100644
--- a/linux-2.6.37.6-antonio/arch/x86/kernel/syscall_table_32.S
+++ b/linux-2.6.37.6-antonio/arch/x86/kernel/syscall_table_32.S
@@ -340,3 +340,7 @@ ENTRY(sys_call_table)
 	.long sys_fanotify_init
 	.long sys_fanotify_mark
 	.long sys_prlimit64		/* 340 */
+	.long sys_checkpoint
+	.long ptregs_rollback
+	.long ptregs_snapshot
+	.long ptregs_stm_ctrl
diff --git a/linux-2.6.37.6-antonio/arch/x86/kvm/emulate.c b/linux-2.6.37.6-antonio/arch/x86/kvm/emulate.c
index 38b6e8d..328e9a7 100644
--- a/linux-2.6.37.6-antonio/arch/x86/kvm/emulate.c
+++ b/linux-2.6.37.6-antonio/arch/x86/kvm/emulate.c
@@ -675,7 +675,7 @@ static int decode_modrm(struct x86_emulate_ctxt *ctxt,
 	c->modrm_rm |= (c->modrm & 0x07);
 	c->modrm_seg = VCPU_SREG_DS;
 
-	if (c->modrm_mod == 3) {
+	if (c->modrm_mod == 3) { // means in register value
 		op->type = OP_REG;
 		op->bytes = (c->d & ByteOp) ? 1 : c->op_bytes;
 		op->addr.reg = decode_register(c->modrm_rm,
@@ -684,7 +684,7 @@ static int decode_modrm(struct x86_emulate_ctxt *ctxt,
 		return rc;
 	}
 
-	op->type = OP_MEM;
+	op->type = OP_MEM; // otherwise mem access
 
 	if (c->ad_bytes == 2) {
 		unsigned bx = c->regs[VCPU_REGS_RBX];
diff --git a/linux-2.6.37.6-antonio/fs/proc/base.c b/linux-2.6.37.6-antonio/fs/proc/base.c
index 1828451..983abc5 100644
--- a/linux-2.6.37.6-antonio/fs/proc/base.c
+++ b/linux-2.6.37.6-antonio/fs/proc/base.c
@@ -362,6 +362,23 @@ static int proc_pid_schedstat(struct task_struct *task, char *buffer)
 }
 #endif
 
+#ifdef CONFIG_STM_ENABLE
+/*
+ * Provides /proc/PID/stm
+ */
+static int proc_pid_stm(struct task_struct *task, char *buffer)
+{
+	return (task->thread_tx) ? sprintf(buffer, "task is tx %s %s %s (%d)\n",
+			(task->thread_tx->status & 0x01) ? "ACTIVE" : "IDLE",
+			((task->thread_tx->status & 0x06) == 0x06) ? "KILL" :
+			  (task->thread_tx->status & 0x02) ? "COMMIT" :
+			    (task->thread_tx->status & 0x04) ? "ABORT" : "none",
+			(task->thread_tx->status & 0x08) ? "IRREVOCABLE" : "none",
+			task->thread_tx->status)
+			: sprintf(buffer, "task is not tx\n");
+}
+#endif
+
 #ifdef CONFIG_LATENCYTOP
 static int lstats_show_proc(struct seq_file *m, void *v)
 {
@@ -2768,6 +2785,9 @@ static const struct pid_entry tgid_base_stuff[] = {
 #ifdef CONFIG_SCHEDSTATS
 	INF("schedstat",  S_IRUGO, proc_pid_schedstat),
 #endif
+#ifdef CONFIG_STM_ENABLE
+	INF("stm",  S_IRUGO, proc_pid_stm),
+#endif
 #ifdef CONFIG_LATENCYTOP
 	REG("latency",  S_IRUGO, proc_lstats_operations),
 #endif
@@ -3104,6 +3124,9 @@ static const struct pid_entry tid_base_stuff[] = {
 #ifdef CONFIG_SCHEDSTATS
 	INF("schedstat", S_IRUGO, proc_pid_schedstat),
 #endif
+#ifdef CONFIG_STM_ENABLE
+	INF("stm", S_IRUGO, proc_pid_stm),
+#endif
 #ifdef CONFIG_LATENCYTOP
 	REG("latency",  S_IRUGO, proc_lstats_operations),
 #endif
diff --git a/linux-2.6.37.6-antonio/include/linux/sched.h b/linux-2.6.37.6-antonio/include/linux/sched.h
index c3dcd7c..54a2967 100644
--- a/linux-2.6.37.6-antonio/include/linux/sched.h
+++ b/linux-2.6.37.6-antonio/include/linux/sched.h
@@ -95,6 +95,7 @@ struct sched_param {
 #include <linux/errno.h>
 #include <linux/nodemask.h>
 #include <linux/mm_types.h>
+#include <linux/stm_types.h>
 
 #include <asm/system.h>
 #include <asm/page.h>
@@ -1147,6 +1148,9 @@ struct sched_statistics {
 	u64			nr_migrations_cold;
 	u64			nr_failed_migrations_affine;
 	u64			nr_failed_migrations_running;
+# ifdef CONFIG_STM_MIGRATION_AVOIDANCE
+	u64			nr_failed_migrations_stm;
+# endif
 	u64			nr_failed_migrations_hot;
 	u64			nr_forced_migrations;
 
@@ -1315,9 +1319,16 @@ struct task_struct {
 	/*
 	 * support for process checkpointing/snapshotting
 	 */
-#ifdef CONFIG_PROCESS_CHECKPOINTING
-	struct list_head checkpoint; /* list of task_struct of this process */
-#endif
+//#ifdef CONFIG_PROCESS_CHECKPOINTING
+//	struct list_head checkpoint; /* list of task_struct of this process */
+//#endif
+	struct hlist_head snapshot; // init the list!!! on process copy/creation
+//	unsigned num_snapshot; // number of snapshots in the list
+
+	/*
+	 * support for STM (codebase TinySTM)
+	 */
+	stm_tx_t* thread_tx;
 
 	/*
 	 * ptraced is the list of tasks this task is using ptrace on.
diff --git a/linux-2.6.37.6-antonio/include/linux/snapshot.h b/linux-2.6.37.6-antonio/include/linux/snapshot.h
new file mode 100644
index 0000000..2dcf345
--- /dev/null
+++ b/linux-2.6.37.6-antonio/include/linux/snapshot.h
@@ -0,0 +1,62 @@
+/*
+ * snapshot.h
+ *
+ *  Created on: Dec 12, 2011
+ *      Author: root
+ */
+
+#ifndef SNAPSHOT_H_
+#define SNAPSHOT_H_
+
+typedef struct __snapshot {
+	struct pt_regs regs;
+	void* usr_stack;
+	int usr_stacksize;
+	int pad_stacksize;
+	unsigned flag; // incremental checkpoints?
+	struct hlist_node next;
+	//TODO
+} snapshot_t;
+
+/* snapshot memory is allocated in kernel snapshot_t first, stack then memory is padded */
+
+/*---------------------*/
+/*   snapshot_t + pad  */
+/*---------------------*/
+/*   usr stack copy    */
+/*---------------------*/
+
+#define SNAP_CREATE_STACK	0x0001
+#define SNAP_CREATE_REGS	0x0002
+#define SNAP_CREATE_FILE	0x0004
+#define SNAP_CREATE_MM		0x0008
+#define SNAP_CREATE_MMIO	0x0010
+#define SNAP_CREATE_		0x0020
+
+/*
+ * SNAP_CREATE_INC create an incremental snapshot
+ * SNAP_CREATE_GZIP saves a compressed copy of the snapshot (to save memory)
+ * SNAP_CREATE_SWAP enforce swapping of the created snapshot (to save memory)
+ */
+#define SNAP_CREATE_INC		0x0100
+#define SNAP_CREATE_GZIP	0x0200
+#define SNAP_CREATE_SWAP	0x0400
+
+#define SNAP_RESTORE_STACK	SNAP_CREATE_STACK
+//same options
+
+#define SNAP_DELETE_OTHER	0x10000
+#define SNAP_DELETE_PREVS	0x20000
+#define SNAP_DELETE_NEXTS	0x40000
+#define SNAP_DELETE_CUR		0x80000
+#define SNAP_DELETE_ALL		(SNAP_DELETE_CUR | SNAP_DELETE_OTHER)
+
+// in task context usage (assume current task context)
+snapshot_t * create_snapshot(__user void * stackaddr, long stacksize, unsigned long flags, struct pt_regs * regs);
+snapshot_t * restore_snapshot (snapshot_t * snap, unsigned long flags, struct pt_regs * regs);
+int delete_snapshot(snapshot_t * psnap, unsigned long flag);
+
+// general usage
+int exit_snapshot(struct task_struct * tsk);
+
+#endif /* SNAPSHOT_H_ */
diff --git a/linux-2.6.37.6-antonio/include/linux/stm.h b/linux-2.6.37.6-antonio/include/linux/stm.h
new file mode 100644
index 0000000..652165c
--- /dev/null
+++ b/linux-2.6.37.6-antonio/include/linux/stm.h
@@ -0,0 +1,437 @@
+/*
+ * File:
+ *   stm.h
+ * Author(s):
+ *   Pascal Felber <pascal.felber@unine.ch>
+ * Description:
+ *   STM functions.
+ *
+ * Copyright (c) 2007-2009.
+ *
+ * This program is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU General Public License
+ * as published by the Free Software Foundation, version 2
+ * of the License.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ */
+
+/**
+ * @file
+ *   STM functions.  This library contains the core functions for
+ *   programming with STM.
+ * @author
+ *   Pascal Felber <pascal.felber@unine.ch>
+ * @date
+ *   2007-2009
+ */
+
+/**
+ * @mainpage TinySTM
+ *
+ * @section overview_sec Overview
+ *
+ *   TinySTM is a lightweight but efficient word-based STM
+ *   implementation.  This distribution includes three versions of
+ *   TinySTM: write-back (updates are buffered until commit time),
+ *   write-through (updates are directly written to memory), and
+ *   commit-time locking (locks are only acquired upon commit).  The
+ *   version can be selected by editing the makefile, which documents
+ *   all the different compilation options.
+ *
+ *   TinySTM compiles and runs on 32 or 64-bit architectures.  It was
+ *   tested on various flavors of Unix, on Mac OS X, and on Windows
+ *   using cygwin.  It comes with a few test applications, notably a
+ *   linked list, a skip list, and a red-black tree.
+ *
+ * @section install_sec Installation
+ *
+ *   TinySTM requires the atomic_ops library, freely available from
+ *   http://www.hpl.hp.com/research/linux/atomic_ops/.  A stripped-down
+ *   version of the library is included in the TinySTM distribution.  If you
+ *   wish to use another version, you must set the environment variable
+ *   <c>LIBAO_HOME</c> to the installation directory of atomic_ops.
+ *
+ *   If your system does not support GCC thread-local storage, set the
+ *   environment variable <c>NOTLS</c> to a non-empty value before
+ *   compilation.
+ *
+ *   To compile TinySTM libraries, execute <c>make</c> in the main
+ *   directory.  To compile test applications, execute <c>make test</c>.
+ *
+ * @section contact_sec Contact
+ *
+ *   - E-mail : tinystm@tinystm.org
+ *   - Web    : http://tinystm.org
+ */
+
+#ifndef _STM_H_
+# define _STM_H_
+
+/* ################################################################### *
+ * TYPES
+ * ################################################################### */
+
+#include <linux/stm_types.h>
+
+/* ################################################################### *
+ * FUNCTIONS
+ * ################################################################### */
+
+/**
+ * Initialize the STM library.  This function must be called once, from
+ * the main thread, before any access to the other functions of the
+ * library.
+ */
+int stm_init(void);
+
+/**
+ * Clean up the STM library.  This function must be called once, from
+ * the main thread, after all transactional threads have completed.
+ */
+void stm_exit(void );
+
+
+/**
+ * Start a transaction.
+ *
+ * @param attr
+ *   Specifies optional attributes associated to the transaction.  If
+ *   null, the transaction uses default attributes.
+ * @return
+ *   Environment (stack context) to be used to jump back upon abort.  It
+ *   is the responsibility of the application to call sigsetjmp()
+ *   immediately after starting the transaction.  If the transaction is
+ *   nested, the function returns NULL and one should not call
+ *   sigsetjmp() as an abort will restart the top-level transaction
+ *   (flat nesting).
+ */
+uintptr_t *stm_start(TXPARAMS stm_tx_attr_t *attr);
+
+/**
+ * Try to commit a transaction.  If successful, the function returns 1.
+ * Otherwise, execution continues at the point where sigsetjmp() has
+ * been called after starting the outermost transaction (unless the
+ * attributes indicate that the transaction should not retry).
+ *
+ * @return
+ *   1 upon success, 0 otherwise.
+ */
+//int stm_commit(TXPARAM);
+int stm_commit(void);
+/**
+ * Explicitly abort a transaction.  Execution continues at the point
+ * where sigsetjmp() has been called after starting the outermost
+ * transaction (unless the attributes indicate that the transaction
+ * should not retry).
+ */
+int stm_abort(TXPARAMS int abort_reason);
+
+/**
+ * Transactional load.  Read the specified memory location in the
+ * context of the current transaction and return its value.  Upon
+ * conflict, the transaction may abort while reading the memory
+ * location.  Note that the value returned is consistent with respect to
+ * previous reads from the same transaction.
+ *
+ * @param addr
+ *   Address of the memory location.
+ * @return
+ *   Value read from the specified address.
+ */
+stm_word_t stm_load(TXPARAMS volatile stm_word_t *addr, stm_word_t *value);
+
+/**
+ * Transactional store.  Write a word-sized value to the specified
+ * memory location in the context of the current transaction.  Upon
+ * conflict, the transaction may abort while writing to the memory
+ * location.
+ *
+ * @param addr
+ *   Address of the memory location.
+ * @param value
+ *   Value to be written.
+ */
+int stm_store(TXPARAMS volatile stm_word_t *addr, stm_word_t value);
+
+/**
+ * Transactional store.  Write a value to the specified memory location
+ * in the context of the current transaction.  The value may be smaller
+ * than a word on the target architecture, in which case a mask is used
+ * to indicate the bits of the words that must be updated.  Upon
+ * conflict, the transaction may abort while writing to the memory
+ * location.
+ *
+ * @param addr
+ *   Address of the memory location.
+ * @param value
+ *   Value to be written.
+ * @param mask
+ *   Mask specifying the bits to be written.
+ */
+int stm_store2(TXPARAMS volatile stm_word_t *addr, stm_word_t value, stm_word_t mask);
+
+/**
+ * Check if the current transaction is still active.
+ *
+ * @return
+ *   True (non-zero) if the transaction is active, false (zero) otherwise.
+ */
+//int stm_active(TXPARAM);
+int stm_active(void);
+
+/**
+ * Check if the current transaction has aborted.
+ *
+ * @return
+ *   True (non-zero) if the transaction has aborted, false (zero) otherwise.
+ */
+//int stm_aborted(TXPARAM);
+int stm_aborted(void);
+
+/**
+ * Check if the current transaction is still active and in irrevocable
+ * state.
+ *
+ * @return 
+ *   True (non-zero) if the transaction is active and irrevocable, false
+ *   (zero) otherwise.
+ */
+//int stm_irrevocable(TXPARAM);
+int stm_irrevocable(void);
+
+/**
+ * Get the environment used by the current thread to jump back upon
+ * abort.  This environment should be used when calling sigsetjmp()
+ * before starting the transaction and passed as parameter to
+ * stm_start().  If the current thread is already executing a
+ * transaction, i.e., the new transaction will be nested, the function
+ * returns NULL and one should not call sigsetjmp().
+ *
+ * @return
+ *   The environment to use for saving the stack context, or NULL if the
+ *   transaction is nested.
+ */
+//sigjmp_buf *stm_get_env(TXPARAM);
+
+/**
+ * Get attributes associated with the current transactions, if any.
+ * These attributes were passed as parameters when starting the
+ * transaction.
+ *
+ * @return Attributes associated with the current transaction, or NULL
+ *   if no attributes were specified when starting the transaction.
+ */
+//stm_tx_attr_t *stm_get_attributes(TXPARAM);
+stm_tx_attr_t *stm_get_attributes(void);
+
+/**
+ * Get various statistics about the current thread/transaction.  See the
+ * source code (stm.c) for a list of supported statistics.
+ *
+ * @param name
+ *   Name of the statistics.
+ * @param val
+ *   Pointer to the variable that should hold the value of the
+ *   statistics.
+ * @return
+ *   1 upon success, 0 otherwise.
+ */
+int stm_get_stats(TXPARAMS const char *name, void *val);
+
+/**
+ * Get various parameters of the STM library.  See the source code
+ * (stm.c) for a list of supported parameters.
+ *
+ * @param name
+ *   Name of the parameter.
+ * @param val
+ *   Pointer to the variable that should hold the value of the
+ *   parameter.
+ * @return
+ *   1 upon success, 0 otherwise.
+ */
+int stm_get_parameter(const char *name, void *val);
+
+/**
+ * Set various parameters of the STM library.  See the source code
+ * (stm.c) for a list of supported parameters.
+ *
+ * @param name
+ *   Name of the parameter.
+ * @param val
+ *   Pointer to a variable that holds the new value of the parameter.
+ * @return
+ *   1 upon success, 0 otherwise.
+ */
+int stm_set_parameter(const char *name, void *val);
+
+/**
+ * Create a key to associate application-specific data to the current
+ * thread/transaction.  This mechanism can be combined with callbacks to
+ * write modules.
+ *
+ * @return
+ *   The new key.
+ */
+int stm_create_specific(void);
+
+/**
+ * Get application-specific data associated to the current
+ * thread/transaction and a given key.
+ *
+ * @param key
+ *   Key designating the data to read.
+ * @return
+ *   Data stored under the given key.
+ */
+void *stm_get_specific(TXPARAMS int key);
+
+/**
+ * Set application-specific data associated to the current
+ * thread/transaction and a given key.
+ *
+ * @param key
+ *   Key designating the data to read.
+ * @param data
+ *   Data to store under the given key.
+ */
+void stm_set_specific(TXPARAMS int key, void *data);
+
+/**
+ * Register application-specific callbacks that are triggered each time
+ * particular events occur.
+ *
+ * @param on_thread_init
+ *   Function called upon initialization of a transactional thread.
+ * @param on_thread_exit
+ *   Function called upon cleanup of a transactional thread.
+ * @param on_start
+ *   Function called upon start of a transaction.
+ * @param on_commit
+ *   Function called upon successful transaction commit.
+ * @param on_abort
+ *   Function called upon transaction abort.
+ * @param arg
+ *   Parameter to be passed to the callback functions.
+ * @return
+ *   1 if the callbacks have been successfully registered, 0 otherwise.
+ */
+/*
+int stm_register(void (*on_thread_init)(TXPARAMS void *arg),
+                 void (*on_thread_exit)(TXPARAMS void *arg),
+                 void (*on_start)(TXPARAMS void *arg),
+                 void (*on_commit)(TXPARAMS void *arg),
+                 void (*on_abort)(TXPARAMS void *arg),
+                 void *arg);
+*/
+/**
+ * Transaction-safe load.  Read the specified memory location outside of
+ * the context of any transaction and return its value.  The operation
+ * behaves as if executed in the context of a dedicated transaction
+ * (i.e., it executes atomically and in isolation) that never aborts,
+ * but may get delayed.
+ *
+ * @param addr Address of the memory location.
+
+ * @param timestamp If non-null, the referenced variable is updated to
+ *   hold the timestamp of the memory location being read.
+ * @return
+ *   Value read from the specified address.
+ */
+stm_word_t stm_unit_load(volatile stm_word_t *addr, stm_word_t *timestamp);
+
+/**
+ * Transaction-safe store.  Write a word-sized value to the specified
+ * memory location outside of the context of any transaction.  The
+ * operation behaves as if executed in the context of a dedicated
+ * transaction (i.e., it executes atomically and in isolation) that
+ * never aborts, but may get delayed.
+ *
+ * @param addr
+ *   Address of the memory location.
+ * @param value
+ *   Value to be written.
+ * @param timestamp If non-null and the timestamp in the referenced
+ *   variable is smaller than that of the memory location being written,
+ *   no data is actually written and the variable is updated to hold the
+ *   more recent timestamp. If non-null and the timestamp in the
+ *   referenced variable is not smaller than that of the memory location
+ *   being written, the memory location is written and the variable is
+ *   updated to hold the new timestamp.
+ * @return
+ *   1 if value has been written, 0 otherwise.
+ */
+int stm_unit_store(volatile stm_word_t *addr, stm_word_t value, stm_word_t *timestamp);
+
+/**
+ * Transaction-safe store.  Write a value to the specified memory
+ * location outside of the context of any transaction.  The value may be
+ * smaller than a word on the target architecture, in which case a mask
+ * is used to indicate the bits of the words that must be updated.  The
+ * operation behaves as if executed in the context of a dedicated
+ * transaction (i.e., it executes atomically and in isolation) that
+ * never aborts, but may get delayed.
+ *
+ * @param addr
+ *   Address of the memory location.
+ * @param value
+ *   Value to be written.
+ * @param mask
+ *   Mask specifying the bits to be written.
+ * @param timestamp If non-null and the timestamp in the referenced
+ *   variable is smaller than that of the memory location being written,
+ *   no data is actually written and the variable is updated to hold the
+ *   more recent timestamp. If non-null and the timestamp in the
+ *   referenced variable is not smaller than that of the memory location
+ *   being written, the memory location is written and the variable is
+ *   updated to hold the new timestamp.
+ * @return
+ *   1 if value has been written, 0 otherwise.
+ */
+int stm_unit_store2(volatile stm_word_t *addr, stm_word_t value, stm_word_t mask, stm_word_t *timestamp);
+
+/**
+ * Enable or disable snapshot extensions for the current transaction,
+ * and optionally set an upper bound for the snapshot.  This function is
+ * useful for implementing efficient algorithms with unit loads and
+ * stores while preserving compatibility with with regular transactions.
+ *
+ * @param enable
+ *   True (non-zero) to enable snapshot extensions, false (zero) to
+ *   disable them.
+ * @param timestamp
+ *   If non-null and the timestamp in the referenced variable is smaller
+ *   than the current upper bound of the snapshot, update the upper
+ *   bound to the value of the referenced variable.
+ */
+void stm_set_extension(TXPARAMS int enable, stm_word_t *timestamp);
+
+/**
+ * Read the current value of the global clock (used for timestamps).
+ * This function is useful when programming with unit loads and stores.
+ *
+ * @return
+ *   Value of the global clock.
+ */
+stm_word_t stm_get_clock(void);
+
+/**
+ * Enter irrevokable mode for the current transaction.  If successful,
+ * the function returns 1.  Otherwise, it aborts and execution continues
+ * at the point where sigsetjmp() has been called after starting the
+ * outermost transaction (unless the attributes indicate that the
+ * transaction should not retry).
+ *
+ * @param enable
+ *   True (non-zero) for serial-irrevocable mode (no transaction can
+ *   execute concurrently), false for parallel-irrevocable mode.
+ * @return
+ *   1 upon success, 0 otherwise.
+ */
+int stm_set_irrevocable(TXPARAMS int serial);
+
+#endif /* _STM_H_ */
